<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">

    <xsl:output method="html" version="4.0" encoding="UTF-8" indent="yes"
        use-character-maps="no-control-characters"/>

    <xsl:character-map name="no-control-characters">
        <xsl:output-character character="&#127;" string=" "/>
        <xsl:output-character character="&#128;" string=" "/>
        <xsl:output-character character="&#129;" string=" "/>
        <xsl:output-character character="&#130;" string=" "/>
        <xsl:output-character character="&#131;" string=" "/>
        <xsl:output-character character="&#132;" string=" "/>
        <xsl:output-character character="&#133;" string=" "/>
        <xsl:output-character character="&#134;" string=" "/>
        <xsl:output-character character="&#135;" string=" "/>
        <xsl:output-character character="&#136;" string=" "/>
        <xsl:output-character character="&#137;" string=" "/>
        <xsl:output-character character="&#138;" string=" "/>
        <xsl:output-character character="&#139;" string=" "/>
        <xsl:output-character character="&#140;" string=" "/>
        <xsl:output-character character="&#141;" string=" "/>
        <xsl:output-character character="&#142;" string=" "/>
        <xsl:output-character character="&#143;" string=" "/>
        <xsl:output-character character="&#144;" string=" "/>
        <xsl:output-character character="&#145;" string=" "/>
        <xsl:output-character character="&#146;" string=" "/>
        <xsl:output-character character="&#147;" string=" "/>
        <xsl:output-character character="&#148;" string=" "/>
        <xsl:output-character character="&#149;" string=" "/>
        <xsl:output-character character="&#150;" string=" "/>
        <xsl:output-character character="&#151;" string=" "/>
        <xsl:output-character character="&#152;" string=" "/>
        <xsl:output-character character="&#153;" string=" "/>
        <xsl:output-character character="&#154;" string=" "/>
        <xsl:output-character character="&#155;" string=" "/>
        <xsl:output-character character="&#156;" string=" "/>
        <xsl:output-character character="&#157;" string=" "/>
        <xsl:output-character character="&#158;" string=" "/>
        <xsl:output-character character="&#159;" string=" "/>
    </xsl:character-map>


    <xsl:template match="/">
        <html>
            <head>
                <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
                <meta name="author" content="brunner"/>
                <title>
                    
                    <xsl:text>lexpan - </xsl:text>
                    <xsl:choose>
                        <xsl:when test="//clusterfile"> Kookkurrenzliste </xsl:when>
                        <xsl:when test="//fillerfile"> Füller </xsl:when>
                        <xsl:when test="//kwicfile">
                            <xsl:choose>
                                <xsl:when test="//kwicfile/@type = 'OVERVIEW'"> KWIC-Überblick </xsl:when>
                                <xsl:otherwise> KWIC </xsl:otherwise>
                            </xsl:choose>
                        </xsl:when>
                    </xsl:choose>


                </title>

                <style>
                    <xsl:value-of select="unparsed-text('../style/lexpan.css', 'UTF-8')"/>
                </style>

                <script type="text/javascript">
                    <xsl:value-of select="unparsed-text('../style/TableSort.js', 'UTF-8')"/>
                </script>

            </head>
            <body>

                <div id="Content">


                    <xsl:apply-templates/>


                </div>

                <div id="Footer" style="clear:left;">
                    <p>
                    <span style="font-size:12px;"> Datei erstellt mit <a href="http://www.ids-mannheim.de/lexik/uwv/lexpan.html">lexpan</a> &#169; Projektgruppe
                        "Usuelle Wortverbindungen", IDS Mannheim</span>
                    </p>
                    <p>
                    <xsl:choose>
                        <xsl:when test="//clusterfile">
                            <xsl:value-of select="//clusterfile/@cite"/>
                        </xsl:when>
                        <xsl:when test="//fillerfile">
                            <xsl:value-of select="//fillerfile/@cite"/>
                        </xsl:when>
                        <xsl:when test="//kwicfile">
                            <xsl:value-of select="//kwicfile/@cite"/>
                        </xsl:when>
                    </xsl:choose>
                    </p>
                </div>


            </body>
        </html>

    </xsl:template>


    <!-- Kwic-Dateien -->
    <xsl:template match="kwicfile">


        <div class="infobox">Die KWIC-Zeilen können durch Klicken auf die Spaltennamen sortiert
            werden.<br/> VORSICHT: Bei sehr vielen Treffern (mehr als ca. 5000) kann dies lange
            dauern und u.U. zum 'Einfrieren' des Browsers führen. </div>
        <xsl:choose>
            <xsl:when test="@type = 'OVERVIEW'">

                <h1>KWIC-Überblicksdatei</h1>
             


                <!-- Index der Tabellen -->
                <ul>
                    <xsl:for-each select="kwictable">
                        <li>
                            <a href="#{generate-id(.)}">
                                <xsl:value-of select="@name"/>
                            </a> (<xsl:value-of select="@size"/> Treffer
                        </li>
                    </xsl:for-each>
                    <xsl:if test="resttable">
                        <li>
                            <a href="#rest">Rest-KWICs</a> (<xsl:value-of select="resttable/@size"/>
                            Treffer) </li>
                    </xsl:if>
                </ul>

            </xsl:when>
            <xsl:otherwise>
                <h1>KWIC-Liste</h1>
            </xsl:otherwise>
        </xsl:choose>

        <xsl:apply-templates/>

    </xsl:template>

    <xsl:template match="kwictable">

        <h2>
            <a name="{generate-id(.)}">
                <xsl:value-of select="@size"/>
                <xsl:text> KWIC-Treffer zu "</xsl:text>
                <xsl:value-of select="@name"/>
                <xsl:text>"</xsl:text>
            </a>
        </h2>
       <p>
        <xsl:if test="@limit!='-1'">
            
                <xsl:text>Exportbeschränkung auf eine Zufallauswahl von maximal </xsl:text> 
                <xsl:value-of select="@limit"/>
                <xsl:text> Treffern</xsl:text>
            <br/>   
        </xsl:if>
        
        
            <xsl:if test="@perc">
               
                <xsl:text>
            Die Gesamttreffermenge entspricht    
            </xsl:text>
                <xsl:value-of select="@perc"/>
                <xsl:text>
             Prozent der KWICs im durchsuchten Store. 
             </xsl:text>
                
            </xsl:if>
       </p>
        
      

        <table class="sortierbar">
            <xsl:apply-templates/>
        </table>

    </xsl:template>

    <xsl:template match="resttable">
        <!-- Unterschiedliche Überschriften je nach Dateityp -->
        <xsl:param name="elemName">
            <xsl:choose>
                <xsl:when test="//fillerfile"> Füller </xsl:when>
                <xsl:when test="//clusterfile"> Partner </xsl:when>
            </xsl:choose>
        </xsl:param>

        <xsl:choose>
            <!-- Kwicfile hat anderes Überschriftformat -->
            <xsl:when test="//kwicfile">
                <h2>
                    <a name="rest">
                        <xsl:value-of select="@size"/>
                        <xsl:text> Rest-KWICs</xsl:text>
                    </a>
                </h2>
                <p>
                    <xsl:text>
            Diese Treffermenge entspricht    
            </xsl:text>
                    <xsl:value-of select="@perc"/>
                    <xsl:text>
             Prozent der KWICs im durchsuchten Store. 
            </xsl:text>
                </p>
            </xsl:when>
            <!-- Partner- und Fuellerdateien sind sehr ähnlich -->
            <xsl:otherwise>
                <h2>
                    <a>
                        <xsl:attribute name="name">
                            <xsl:text>rest</xsl:text>
                        </xsl:attribute> Restmenge </a>
                </h2>
                <p>
                    <xsl:value-of select="@size"/>
                    <xsl:choose>
                        <xsl:when test="@size > 1"> unterschiedliche <xsl:value-of
                                select="$elemName"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:value-of select="$elemName"/>
                        </xsl:otherwise>
                    </xsl:choose>
                </p>

            </xsl:otherwise>
        </xsl:choose>

        <!--Tabelle nur anlegen, wenn sie nicht leer ist-->
        <xsl:if test="@size > 0">
            <table class="sortierbar">
                <xsl:apply-templates/>
            </table>
        </xsl:if>
    </xsl:template>


    <!-- Partnerdateien -->
    <xsl:template match="clusterfile">
        <div class="infobox"> Die Partner können durch Klicken auf den Namen der Tabellenspalten
            sortiert werden. </div>
        <xsl:apply-templates/>
    </xsl:template>



    <xsl:template match="clusterinfo">
        <!-- different header design depending on clusterfile type -->

        <h1>
            <xsl:text>Cluster der Kookkurrenzliste "</xsl:text>
            <xsl:value-of select="@prof"/>
            <xsl:text>"</xsl:text>
        </h1>

        <!-- if there is more than one table following, an index is created -->
        <xsl:if test="//resttable or count(//clustertable) > 1">
            <ul>
                <xsl:for-each select="//clustertable">
                    <li>
                        <a>
                            <xsl:attribute name="href">
                                <xsl:text>#</xsl:text>
                                <xsl:value-of select="@name"/>
                            </xsl:attribute>
                            <xsl:choose>
                                <xsl:when test="//clusterfile/@type = 'TAGCOMB'"> Tag-Kombination </xsl:when>
                                <xsl:otherwise> Tag </xsl:otherwise>
                            </xsl:choose>
                            <xsl:value-of select="@name"/>
                        </a>
                    </li>
                </xsl:for-each>
                <xsl:if test="//resttable">
                  
                    <li>
                        <a>
                            <xsl:attribute name="href">
                                <xsl:text>#rest</xsl:text>
                            </xsl:attribute> Restmenge </a>
                    </li>
                </xsl:if>
            </ul>
        </xsl:if>

        <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="clustertable">
        <!-- keine Zwischenüberschriften, wenn das Cluster gesamt gedruckt wird -->
        <xsl:if test="//clusterfile/@type != 'CLUSTER'">
            <h2>
                <a>
                    <xsl:attribute name="name">
                        <xsl:value-of select="@name"/>
                    </xsl:attribute>
                    <xsl:choose>
                        <xsl:when test="//clusterfile/@type = 'TAGCOMB'"> Tag-Kombination </xsl:when>
                        <xsl:otherwise> Tag </xsl:otherwise>
                    </xsl:choose>
                    <xsl:text> </xsl:text>
                    <xsl:value-of select="@name"/>
                </a>
            </h2>
        </xsl:if>
        <p>
            <xsl:value-of select="@size"/>
            <xsl:choose>
                <xsl:when test="@size > 1"> unterschiedliche Partner<br/>
                </xsl:when>
                <xsl:otherwise> Partner<br/>
                </xsl:otherwise>
            </xsl:choose>
        </p>
        <xsl:if test="@freqLim">
            <p>
                Gezeigt werden nur Tabellenzeilen mit mindestens <xsl:value-of select="@freqLim"/> zugeordneten KWICs.
            </p>
        </xsl:if>


        <table class="sortierbar">
            <xsl:apply-templates/>
        </table>
    </xsl:template>


    <!-- Fueller-Tabellen -->
    <xsl:template match="fillerfile">
        <div class="infobox"> Die Füller können durch Klicken auf den Namen der Tabellenspalten
            sortiert werden. </div>

        <h1>
            <xsl:choose>
                <xsl:when test="count(//fillertable) > 1 or //resttable"> Füller-Tabellen </xsl:when>
                <xsl:otherwise>Füller-Tabelle</xsl:otherwise>
            </xsl:choose>
            <xsl:if test="@type = 'ALLGAPS'">
                <xsl:text> für alle Lücken der Suchanfrage</xsl:text>
            </xsl:if>
        </h1>
        
        <!-- display the info about how many kwic lines were covered by this wvpattern -->
      
            <p>
                <xsl:text>Die Suchanfrage erfasst </xsl:text>
                <xsl:value-of select="@nrKwics"/>
                <xsl:text> KWICs.</xsl:text>
            </p>
        


        <xsl:apply-templates/>

    </xsl:template>

    <xsl:template match="fillerPosTable">
        <table class="fillerPosTable">
            <p>Die unterlegten Zellen verlinken zu den entsprechenden Füllertabellen.</p>
            <tr>
                <td>
                    <b>Suchanfrage</b>
                </td>
                <xsl:for-each select="row[1]">
                    <xsl:apply-templates/>
                </xsl:for-each>
            </tr>
        </table>
    </xsl:template>

    <xsl:template match="fieldname">
        <xsl:apply-templates/>
        <br/>
    </xsl:template>


    <xsl:template match="fillerinfo">
        <!-- different header design depending on fillerfile type -->
        <xsl:choose>
            <!-- for ALLGAPS fillerinfo is a sub-headline, because there are more than one fillerinfo -->
            <xsl:when test="//fillerfile/@type = 'ALLGAPS'">
                <h2>
                    <a>
                        <xsl:attribute name="name">
                            <xsl:text>field</xsl:text>
                            <xsl:value-of select="@field"/>
                        </xsl:attribute>
                        <xsl:text>Füllertabelle für Feld </xsl:text>
                        <xsl:value-of select="@field"/>
                    </a>
                </h2>
            </xsl:when>
            <xsl:otherwise>
                <h1>
                    <xsl:text>Füller zur Suchanfrage "</xsl:text>
                    <xsl:value-of select="@wvPat"/>
                    <xsl:text>", Feld </xsl:text>
                    <xsl:value-of select="@field"/>
                   
                </h1>
           
                <!-- if there is more than one table following, an index is created -->
                <xsl:if test="//resttable or count(//fillertable) > 1">
                    <ul>
                        <xsl:for-each select="//fillertable">
                            <li>
                                <a>
                                    <xsl:attribute name="href">
                                        <xsl:text>#</xsl:text>
                                        <xsl:value-of select="@name"/>
                                    </xsl:attribute>
                                    <xsl:choose>
                                        <xsl:when test="//fillerfile/@type = 'TAGCOMB'">
                                            Tag-Kombination </xsl:when>
                                        <xsl:otherwise> Tag </xsl:otherwise>
                                    </xsl:choose>
                                    <xsl:value-of select="@name"/>
                                </a>
                            </li>
                        </xsl:for-each>
                        <xsl:if test="//resttable">
                            <li>
                                <a>
                                    <xsl:attribute name="href">
                                        <xsl:text>#rest</xsl:text>
                                    </xsl:attribute> Restmenge </a>
                            </li>
                        </xsl:if>
                    </ul>
                </xsl:if>
            </xsl:otherwise>
        </xsl:choose>

        <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="fillertable">
        <xsl:choose>
            <!-- ALLGAPS und GAP hat immer nur eine fillertable pro fillerinfo und braucht keine 
            Zwischenueberschrift; diese erscheint nur fuer die TAG-Typen-->
            <xsl:when test="not(/fillerfile/@type = 'ALLGAPS') and not(/fillerfile/@type = 'GAP')">

                <h2>
                    <a>
                        <xsl:attribute name="name">
                            <xsl:value-of select="@name"/>
                        </xsl:attribute>
                        <xsl:choose>
                            <xsl:when test="//fillerfile/@type = 'TAGCOMB'"> Tag-Kombination </xsl:when>
                            <xsl:otherwise> Tag </xsl:otherwise>
                        </xsl:choose>
                        <xsl:text> </xsl:text>
                        <xsl:value-of select="@name"/>
                    </a>
                </h2>

            </xsl:when>
        </xsl:choose>
        <p>

            <xsl:value-of select="@size"/>
            <xsl:choose>
                <xsl:when test="@size > 1"> unterschiedliche Füller </xsl:when>
                <xsl:otherwise> Füller </xsl:otherwise>
            </xsl:choose>
        </p>
        <xsl:if test="@freqLim">
            <p>
                Gezeigt werden nur Tabellenzeilen mit mindestens <xsl:value-of select="@freqLim"/> zugeordneten KWICs.
            </p>
        </xsl:if>


        <table class="sortierbar">
            <xsl:apply-templates/>
        </table>
    </xsl:template>

    <!-- Allgemeine Tabellenfunktionen -->
    <xsl:template match="tbody">
        <tbody>
            <xsl:apply-templates/>
        </tbody>
    </xsl:template>

    <xsl:template match="thead">
        <thead>
            <xsl:apply-templates/>
        </thead>
    </xsl:template>

    <xsl:template match="row">
        <xsl:param name="file"/>
        <tr>
            <xsl:apply-templates>
                <xsl:with-param name="file" select="$file"/>
            </xsl:apply-templates>
        </tr>
    </xsl:template>

    <xsl:template match="head">
        <xsl:param name="file"/>
        <th>
            <xsl:if test="@colspan">
                <xsl:attribute name="colspan">
                    <xsl:value-of select="@colspan"/>
                </xsl:attribute>
            </xsl:if>
            <xsl:apply-templates>
                <xsl:with-param name="file" select="$file"/>
            </xsl:apply-templates>
        </th>
    </xsl:template>

    <xsl:template match="cell">
        <td>
            <xsl:if test="@class">
                <xsl:attribute name="class">
                    <xsl:value-of select="@class"/>
                </xsl:attribute>
            </xsl:if>
            <xsl:if test="@colspan">
                <xsl:attribute name="colspan">
                    <xsl:value-of select="@colspan"/>
                </xsl:attribute>
                <xsl:attribute name="style">
                    <xsl:text>text-align: center;</xsl:text>
                </xsl:attribute>
            </xsl:if>
            <xsl:choose>
                <!-- @fieldref means an internal link to a field table -->
                <xsl:when test="@fieldref">
                    <xsl:attribute name="class">fieldref</xsl:attribute>

                    <a>
                        <xsl:attribute name="href">
                            <xsl:text>#field</xsl:text>
                            <xsl:value-of select="@fieldref"/>
                        </xsl:attribute>
                        <xsl:apply-templates/>
                    </a>
                </xsl:when>
                <!-- @ref means an external link to a dependent kwic file -->
                <xsl:when test="@ref">
                    <a>
                        <xsl:attribute name="href">
                            <xsl:value-of select="@ref"/>
                        </xsl:attribute>
                        <xsl:apply-templates/>
                    </a>

                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates/>
                </xsl:otherwise>
            </xsl:choose>
        </td>

    </xsl:template>


</xsl:stylesheet>
