<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    exclude-result-prefixes="xs"
    version="2.0">
    
    <xsl:template match="export">
        <concordance>
            <heading>
                <xsl:apply-templates select="header"/>
            </heading>
                <xsl:apply-templates select="concordance"/>
        </concordance>
    </xsl:template>
    
    <xsl:template match="header">
        <corpus>
            <xsl:apply-templates select="corpus"/>
            <xsl:text> (</xsl:text>
            <xsl:apply-templates select="subcorpus"/>
            <xsl:text>)</xsl:text>
        </corpus>
        <hits>
            <!-- geht the number of the last line-element and add 1 
            (because count in input file starts with 0-->
            <xsl:value-of select="(//line)[last()]/@num + 1"/>
        </hits>
        <query>
            <xsl:apply-templates select="query"/>
        </query>
    </xsl:template>
    
    <xsl:template match="concordance">
        <xsl:apply-templates/>
    </xsl:template>
    
    <xsl:template match="line">
        <line>
            <ref>
                <xsl:value-of select="@refs"/>
                <xsl:text>_</xsl:text>
                <xsl:value-of select="@num"/>
            </ref>
            <left_context>
                <xsl:apply-templates select="left"/>
            </left_context>
            <kwic>
                <xsl:apply-templates select="kwic"/>
            </kwic>
            <right_context>
                <xsl:apply-templates select="right"/>
            </right_context>
        </line>
    </xsl:template>
    
</xsl:stylesheet>